diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-mac.cc ns-3.43/src/wifi/model/wifi-mac.cc
--- ns-3.42/src/wifi/model/wifi-mac.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-mac.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -34,9 +23,11 @@
 #include "ns3/he-configuration.h"
 #include "ns3/ht-configuration.h"
 #include "ns3/log.h"
+#include "ns3/object-vector.h"
 #include "ns3/packet.h"
 #include "ns3/pointer.h"
 #include "ns3/shuffle.h"
+#include "ns3/socket.h"
 #include "ns3/string.h"
 #include "ns3/vht-configuration.h"
 
@@ -136,6 +127,18 @@
                           MakePointerAccessor(&WifiMac::GetBKQueue, &WifiMac::SetBkQueue),
                           MakePointerChecker<QosTxop>())
             .AddAttribute(
+                "ChannelAccessManagers",
+                "The Channel Access Manager(s) attached to this device.",
+                ObjectVectorValue(),
+                MakeObjectVectorAccessor(&WifiMac::GetChannelAccessManager, &WifiMac::GetNLinks),
+                MakeObjectVectorChecker<ChannelAccessManager>())
+            .AddAttribute(
+                "FrameExchangeManagers",
+                "The Frame Exchange Manager(s) attached to this device.",
+                ObjectVectorValue(),
+                MakeObjectVectorAccessor(&WifiMac::GetFrameExchangeManager, &WifiMac::GetNLinks),
+                MakeObjectVectorChecker<FrameExchangeManager>())
+            .AddAttribute(
                 "MpduBufferSize",
                 "The size (in number of MPDUs) of the buffer used for each BlockAck "
                 "agreement in which this node is a recipient. The provided value is "
@@ -356,7 +359,14 @@
                 "a SU frame or aggregated to PSDUs in the DL MU PPDU), a Basic Trigger Frame or "
                 "a BSRP Trigger Frame.",
                 MakeTraceSourceAccessor(&WifiMac::m_psduMapResponseTimeoutCallback),
-                "ns3::WifiMac::PsduMapResponseTimeoutCallback");
+                "ns3::WifiMac::PsduMapResponseTimeoutCallback")
+            .AddTraceSource("IcfDropReason",
+                            "An ICF is dropped by an EMLSR client for the given reason on the "
+                            "link with the given ID. This trace source is actually fed by the "
+                            "EHT Frame Exchange Manager through the m_icfDropCallback member "
+                            "variable.",
+                            MakeTraceSourceAccessor(&WifiMac::m_icfDropCallback),
+                            "ns3::WifiMac::IcfDropCallback");
     return tid;
 }
 
@@ -972,6 +982,11 @@
             MakeCallback(&DroppedMpduTracedCallback::operator(), &m_droppedMpduCallback));
         link->feManager->SetAckedMpduCallback(
             MakeCallback(&MpduTracedCallback::operator(), &m_ackedMpduCallback));
+        if (auto ehtFem = DynamicCast<EhtFrameExchangeManager>(link->feManager))
+        {
+            ehtFem->m_icfDropCallback.ConnectWithoutContext(
+                MakeCallback(&IcfDropTracedCallback::operator(), &m_icfDropCallback));
+        }
     }
 
     CompleteConfig();
@@ -1135,7 +1150,12 @@
 {
     NS_LOG_FUNCTION(this);
 
-    std::map<uint8_t, uint8_t> actualPairs;
+    // save the initial mapping between link IDs and link Entities
+    std::map<uint8_t, std::reference_wrapper<const LinkEntity>> origLinkRefMap;
+    for (const auto& [id, link] : m_links)
+    {
+        origLinkRefMap.insert_or_assign(id, *link.get());
+    }
 
     while (!links.empty())
     {
@@ -1159,8 +1179,6 @@
             auto [it, inserted] =
                 m_links.emplace(to, nullptr); // insert an element with key to if not present
             m_links[to].swap(linkToMove);     // to is the link to move now
-            actualPairs.emplace(from, to);
-            UpdateLinkId(to);
             links.erase(from);
             if (!linkToMove)
             {
@@ -1176,7 +1194,6 @@
             {
                 // no new position specified for 'to', use the current empty cell
                 m_links[empty].swap(linkToMove);
-                actualPairs.emplace(to, empty);
                 break;
             }
 
@@ -1191,6 +1208,22 @@
         m_linkIds.insert(id);
     }
 
+    std::map<uint8_t, uint8_t> actualPairs;
+    for (const auto& [from, ref] : origLinkRefMap)
+    {
+        // find the pointer in the current link map
+        for (const auto& [to, link] : m_links)
+        {
+            if (link.get() == &ref.get())
+            {
+                actualPairs[from] = to; // link 'from' became link 'to'
+                UpdateLinkId(to);
+                break;
+            }
+        }
+    }
+    NS_ASSERT_MSG(actualPairs.size() == m_links.size(), "Missing some link(s)");
+
     if (m_txop)
     {
         m_txop->SwapLinks(actualPairs);
@@ -1617,15 +1650,99 @@
     }
 }
 
+bool
+WifiMac::GetTxBlockedOnLink(AcIndex ac,
+                            const WifiContainerQueueId& queueId,
+                            uint8_t linkId,
+                            WifiQueueBlockedReason reason) const
+{
+    auto mask = m_scheduler->GetQueueLinkMask(ac, queueId, linkId);
+
+    if (!mask.has_value())
+    {
+        return true; // the link may have not been setup
+    }
+    if (reason == WifiQueueBlockedReason::REASONS_COUNT)
+    {
+        return mask->any();
+    }
+    return mask->test(static_cast<std::size_t>(reason));
+}
+
+void
+WifiMac::Enqueue(Ptr<Packet> packet, Mac48Address to)
+{
+    NS_LOG_FUNCTION(this << packet << to);
+    // We're sending this packet with a from address that is our own. We
+    // get that address from the lower MAC and make use of the
+    // from-spoofing Enqueue() method to avoid duplicated code.
+    Enqueue(packet, to, GetAddress());
+}
+
 void
 WifiMac::Enqueue(Ptr<Packet> packet, Mac48Address to, Mac48Address from)
 {
-    // We expect WifiMac subclasses which do support forwarding (e.g.,
-    // AP) to override this method. Therefore, we throw a fatal error if
-    // someone tries to invoke this method on a class which has not done
-    // this.
-    NS_FATAL_ERROR("This MAC entity (" << this << ", " << GetAddress()
-                                       << ") does not support Enqueue() with from address");
+    NS_LOG_FUNCTION(this << packet << to << from);
+
+    // If we are not a QoS AP then we definitely want to use AC_BE to
+    // transmit the packet. A TID of zero will map to AC_BE (through \c
+    // QosUtilsMapTidToAc()), so we use that as our default here.
+    uint8_t tid = 0;
+
+    SocketPriorityTag qos;
+    if (packet->RemovePacketTag(qos) && qos.GetPriority() < 8)
+    {
+        tid = qos.GetPriority();
+    }
+
+    Enqueue(packet, to, from, tid);
+}
+
+void
+WifiMac::Enqueue(Ptr<Packet> packet, Mac48Address to, Mac48Address from, uint8_t tid)
+{
+    NS_LOG_FUNCTION(this << packet << to << from << tid);
+
+    NS_ABORT_MSG_IF(!SupportsSendFrom() && from != GetAddress(),
+                    "This Mac does not support forwarding frames");
+
+    if (!CanForwardPacketsTo(to))
+    {
+        NotifyTxDrop(packet);
+        NotifyDropPacketToEnqueue(packet, to);
+        return;
+    }
+
+    WifiMacHeader hdr;
+
+    // For now, an AP that supports QoS does not support non-QoS
+    // associations, and vice versa. In future the AP model should
+    // support simultaneously associated QoS and non-QoS STAs, at which
+    // point there will need to be per-association QoS state maintained
+    // by the association state machine, and consulted here.
+    if (GetQosSupported())
+    {
+        hdr.SetType(WIFI_MAC_QOSDATA);
+        hdr.SetQosAckPolicy(WifiMacHeader::NORMAL_ACK);
+        hdr.SetQosNoEosp();
+        hdr.SetQosNoAmsdu();
+        hdr.SetQosTid(tid);
+        hdr.SetNoOrder(); // explicitly set to 0 for the time being since HT control field is not
+                          // yet implemented (set it to 1 when implemented)
+    }
+    else
+    {
+        hdr.SetType(WIFI_MAC_DATA);
+    }
+
+    // create an MPDU and pass it to subclasses to finalize MAC header
+    Enqueue(Create<WifiMpdu>(packet, hdr), to, from);
+}
+
+void
+WifiMac::NotifyDropPacketToEnqueue(Ptr<Packet> packet, Mac48Address to)
+{
+    NS_LOG_FUNCTION(this << packet << to);
 }
 
 void
@@ -1640,11 +1757,10 @@
 {
     NS_LOG_FUNCTION(this << *mpdu << linkId);
 
-    const WifiMacHeader* hdr = &mpdu->GetOriginal()->GetHeader();
-    Mac48Address to = hdr->GetAddr1();
-    Mac48Address from = hdr->GetAddr2();
-    auto myAddr = hdr->IsData() ? Mac48Address::ConvertFrom(GetDevice()->GetAddress())
-                                : GetFrameExchangeManager(linkId)->GetAddress();
+    const auto& hdr = mpdu->GetOriginal()->GetHeader();
+    const auto to = hdr.GetAddr1();
+    const auto myAddr = hdr.IsData() ? Mac48Address::ConvertFrom(GetDevice()->GetAddress())
+                                     : GetFrameExchangeManager(linkId)->GetAddress();
 
     // We don't know how to deal with any frame that is not addressed to
     // us (and odds are there is nothing sensible we could do anyway),
@@ -1657,105 +1773,13 @@
         return;
     }
 
-    // Nothing to do with (QoS) Null Data frames
-    if (hdr->IsData() && !hdr->HasData())
+    // Nothing to do with (QoS) Null Data frames or management frames
+    if ((hdr.IsData() && !hdr.HasData()) || hdr.IsMgt())
     {
         return;
     }
 
-    if (hdr->IsMgt() && hdr->IsAction())
-    {
-        // There is currently only any reason for Management Action
-        // frames to be flying about if we are a QoS STA.
-        NS_ASSERT(GetQosSupported());
-
-        auto& link = GetLink(linkId);
-        WifiActionHeader actionHdr;
-        Ptr<Packet> packet = mpdu->GetPacket()->Copy();
-        packet->RemoveHeader(actionHdr);
-
-        switch (actionHdr.GetCategory())
-        {
-        case WifiActionHeader::BLOCK_ACK:
-
-            switch (actionHdr.GetAction().blockAck)
-            {
-            case WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST: {
-                MgtAddBaRequestHeader reqHdr;
-                packet->RemoveHeader(reqHdr);
-
-                // We've received an ADDBA Request. Our policy here is
-                // to automatically accept it, so we get the ADDBA
-                // Response on it's way immediately.
-                NS_ASSERT(link.feManager);
-                auto htFem = DynamicCast<HtFrameExchangeManager>(link.feManager);
-                if (htFem)
-                {
-                    htFem->SendAddBaResponse(&reqHdr, from);
-                }
-                // This frame is now completely dealt with, so we're done.
-                return;
-            }
-            case WifiActionHeader::BLOCK_ACK_ADDBA_RESPONSE: {
-                MgtAddBaResponseHeader respHdr;
-                packet->RemoveHeader(respHdr);
-
-                // We've received an ADDBA Response. We assume that it
-                // indicates success after an ADDBA Request we have
-                // sent (we could, in principle, check this, but it
-                // seems a waste given the level of the current model)
-                // and act by locally establishing the agreement on
-                // the appropriate queue.
-                auto recipientMld = link.stationManager->GetMldAddress(from);
-                auto recipient = (recipientMld ? *recipientMld : from);
-                GetQosTxop(respHdr.GetTid())->GotAddBaResponse(respHdr, recipient);
-                auto htFem = DynamicCast<HtFrameExchangeManager>(link.feManager);
-                if (htFem)
-                {
-                    GetQosTxop(respHdr.GetTid())
-                        ->GetBaManager()
-                        ->SetBlockAckInactivityCallback(
-                            MakeCallback(&HtFrameExchangeManager::SendDelbaFrame, htFem));
-                }
-                // This frame is now completely dealt with, so we're done.
-                return;
-            }
-            case WifiActionHeader::BLOCK_ACK_DELBA: {
-                MgtDelBaHeader delBaHdr;
-                packet->RemoveHeader(delBaHdr);
-                auto recipientMld = link.stationManager->GetMldAddress(from);
-                auto recipient = (recipientMld ? *recipientMld : from);
-
-                if (delBaHdr.IsByOriginator())
-                {
-                    // This DELBA frame was sent by the originator, so
-                    // this means that an ingoing established
-                    // agreement exists in BlockAckManager and we need to
-                    // destroy it.
-                    GetQosTxop(delBaHdr.GetTid())
-                        ->GetBaManager()
-                        ->DestroyRecipientAgreement(recipient, delBaHdr.GetTid());
-                }
-                else
-                {
-                    // We must have been the originator. We need to
-                    // tell the correct queue that the agreement has
-                    // been torn down
-                    GetQosTxop(delBaHdr.GetTid())->GotDelBaFrame(&delBaHdr, recipient);
-                }
-                // This frame is now completely dealt with, so we're done.
-                return;
-            }
-            default:
-                NS_FATAL_ERROR("Unsupported Action field in Block Ack Action frame");
-                return;
-            }
-        default:
-            NS_FATAL_ERROR("Unsupported Action frame received");
-            return;
-        }
-    }
-    NS_FATAL_ERROR("Don't know how to handle frame (type=" << hdr->GetType());
+    NS_FATAL_ERROR("Don't know how to handle frame (type=" << hdr.GetType());
 }
 
 void
@@ -1807,7 +1831,7 @@
         // this is a single link device
         return m_address;
     }
-    // this is an MLD (hence the remote device is single link)
+    // this is an MLD (hence the remote device is single link or unknown)
     return DoGetLocalAddress(remoteAddr);
 }
 
@@ -2093,8 +2117,6 @@
 {
     NS_LOG_FUNCTION(this);
     ExtendedCapabilities capabilities;
-    capabilities.SetHtSupported(GetHtSupported(SINGLE_LINK_OP_ID));
-    capabilities.SetVhtSupported(GetVhtSupported(SINGLE_LINK_OP_ID));
     // TODO: to be completed
     return capabilities;
 }
@@ -2139,7 +2161,7 @@
         uint8_t nss = (mcs.GetMcsValue() / 8) + 1;
         NS_ASSERT(nss > 0 && nss < 5);
         uint64_t dataRate = mcs.GetDataRate(htConfiguration->Get40MHzOperationSupported() ? 40 : 20,
-                                            sgiSupported ? 400 : 800,
+                                            NanoSeconds(sgiSupported ? 400 : 800),
                                             nss);
         if (dataRate > maxSupportedRate)
         {
@@ -2216,7 +2238,7 @@
         capabilities.SetTxMcsMap(maxMcs, nss);
     }
     uint64_t maxSupportedRateLGI = 0; // in bit/s
-    uint16_t maxWidth = vhtConfiguration->Get160MHzOperationSupported() ? 160 : 80;
+    MHz_u maxWidth = vhtConfiguration->Get160MHzOperationSupported() ? 160 : 80;
     for (const auto& mcs : phy->GetMcsList(WIFI_MOD_CLASS_VHT))
     {
         if (!mcs.IsAllowed(maxWidth, 1))
@@ -2269,7 +2291,7 @@
     }
     capabilities.SetChannelWidthSet(channelWidthSet);
     capabilities.SetLdpcCodingInPayload(htConfiguration->GetLdpcSupported());
-    if (heConfiguration->GetGuardInterval() == NanoSeconds(800))
+    if (heConfiguration->GetGuardInterval().GetNanoSeconds() == 800)
     {
         // todo: We assume for now that if we support 800ns GI then 1600ns GI is supported as well
         // todo: Assuming reception support for both 1x HE LTF and 4x HE LTF 800 ns
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-mac.h ns-3.43/src/wifi/model/wifi-mac.h
--- ns-3.42/src/wifi/model/wifi-mac.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-mac.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -58,6 +47,7 @@
 class OriginatorBlockAckAgreement;
 class RecipientBlockAckAgreement;
 class UniformRandomVariable;
+enum class WifiIcfDrop : uint8_t; // opaque enum declaration
 
 /**
  * \ingroup wifi
@@ -363,6 +353,22 @@
                                  const std::set<uint8_t>& linkIds);
 
     /**
+     * Check whether the transmission of the packets in the given container queue of the given
+     * Access Category are blocked on the given link for the given reason (if any).
+     *
+     * \param ac the given Access Category
+     * \param queueId the given container queue
+     * \param linkId the ID of the given link
+     * \param reason the reason to block transmissions (REASONS_COUNT indicate no reason)
+     * \return whether transmission is blocked
+     */
+    bool GetTxBlockedOnLink(
+        AcIndex ac,
+        const WifiContainerQueueId& queueId,
+        uint8_t linkId,
+        WifiQueueBlockedReason reason = WifiQueueBlockedReason::REASONS_COUNT) const;
+
+    /**
      * Return true if packets can be forwarded to the given destination,
      * false otherwise.
      *
@@ -370,27 +376,43 @@
      * \return whether packets can be forwarded to the given destination
      */
     virtual bool CanForwardPacketsTo(Mac48Address to) const = 0;
+
+    /**
+     * \param packet the packet to send.
+     * \param to the address to which the packet should be sent.
+     *
+     * The packet should be enqueued in a TX queue, and should be
+     * dequeued as soon as the DCF/EDCA function determines that
+     * access is granted to this MAC.
+     */
+    void Enqueue(Ptr<Packet> packet, Mac48Address to);
+
     /**
      * \param packet the packet to send.
      * \param to the address to which the packet should be sent.
      * \param from the address from which the packet should be sent.
      *
      * The packet should be enqueued in a TX queue, and should be
-     * dequeued as soon as the DCF function determines that
-     * access it granted to this MAC. The extra parameter "from" allows
+     * dequeued as soon as the DCF/EDCA function determines that
+     * access is granted to this MAC. The extra parameter "from" allows
      * this device to operate in a bridged mode, forwarding received
      * frames without altering the source address.
      */
-    virtual void Enqueue(Ptr<Packet> packet, Mac48Address to, Mac48Address from);
+    void Enqueue(Ptr<Packet> packet, Mac48Address to, Mac48Address from);
+
     /**
      * \param packet the packet to send.
      * \param to the address to which the packet should be sent.
+     * \param from the address from which the packet should be sent.
+     * \param tid the TID to use to send this packet
      *
      * The packet should be enqueued in a TX queue, and should be
-     * dequeued as soon as the DCF function determines that
-     * access it granted to this MAC.
+     * dequeued as soon as the DCF/EDCA function determines that
+     * access is granted to this MAC. The extra parameter "tid" allows
+     * to specify the TID to use in case QoS is supported.
      */
-    virtual void Enqueue(Ptr<Packet> packet, Mac48Address to) = 0;
+    void Enqueue(Ptr<Packet> packet, Mac48Address to, Mac48Address from, uint8_t tid);
+
     /**
      * \return if this MAC supports sending from arbitrary address.
      *
@@ -1115,6 +1137,24 @@
     void SetBkBlockAckInactivityTimeout(uint16_t timeout);
 
     /**
+     * \param mpdu the MPDU to send.
+     * \param to the address to which the packet should be sent.
+     * \param from the address from which the packet should be sent.
+     *
+     * Subclasses need to implement this method to finalize the MAC header of the MPDU
+     * (MAC addresses and ToDS/FromDS flags) and enqueue the MPDU in a TX queue.
+     */
+    virtual void Enqueue(Ptr<WifiMpdu> mpdu, Mac48Address to, Mac48Address from) = 0;
+
+    /**
+     * Allow subclasses to take actions when a packet to enqueue has been dropped.
+     *
+     * \param packet the dropped packet
+     * \param to the address to which the packet should have been sent
+     */
+    virtual void NotifyDropPacketToEnqueue(Ptr<Packet> packet, Mac48Address to);
+
+    /**
      * This Boolean is set \c true iff this WifiMac is to model
      * 802.11e/WMM style Quality of Service. It is exposed through the
      * attribute system.
@@ -1295,6 +1335,19 @@
      * This trace source is fed by a WifiTxTimer object.
      */
     PsduMapResponseTimeoutTracedCallback m_psduMapResponseTimeoutCallback;
+
+    /**
+     * TracedCallback signature for ICF drop events.
+     *
+     * \param reason the reason why the ICF was dropped by the EMLSR client
+     * \param linkId the ID of the link on which the ICF was dropped
+     */
+    typedef void (*IcfDropCallback)(WifiIcfDrop reason, uint8_t linkId);
+
+    /// TracedCallback for ICF drop events typedef
+    using IcfDropTracedCallback = TracedCallback<WifiIcfDrop, uint8_t>;
+
+    IcfDropTracedCallback m_icfDropCallback; //!< traced callback for ICF drop events
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-mac-header.cc ns-3.43/src/wifi/model/wifi-mac-header.cc
--- ns-3.42/src/wifi/model/wifi-mac-header.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-mac-header.cc	2024-10-09 16:41:10.128656900 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2006, 2009 INRIA
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
@@ -57,32 +46,12 @@
     SUBTYPE_CTL_END_ACK = 15
 };
 
-WifiMacHeader::WifiMacHeader()
-    : m_ctrlMoreFrag(0),
-      m_ctrlRetry(0),
-      m_ctrlPowerManagement(0),
-      m_ctrlMoreData(0),
-      m_ctrlWep(0),
-      m_ctrlOrder(0),
-      m_duration(0),
-      m_seqFrag(0),
-      m_seqSeq(0),
-      m_qosEosp(0),
-      m_qosAckPolicy(0), // Normal Ack
-      m_amsduPresent(0)
-{
-}
-
 WifiMacHeader::WifiMacHeader(WifiMacType type)
     : WifiMacHeader()
 {
     SetType(type);
 }
 
-WifiMacHeader::~WifiMacHeader()
-{
-}
-
 void
 WifiMacHeader::SetDsFrom()
 {
@@ -1175,15 +1144,15 @@
         os << " Duration/ID=" << m_duration << "us";
         if (!m_ctrlToDs && !m_ctrlFromDs)
         {
-            os << ", DA=" << m_addr1 << ", SA=" << m_addr2 << ", BSSID=" << m_addr3;
+            os << ", DA(RA)=" << m_addr1 << ", SA(TA)=" << m_addr2 << ", BSSID=" << m_addr3;
         }
         else if (!m_ctrlToDs && m_ctrlFromDs)
         {
-            os << ", DA=" << m_addr1 << ", SA=" << m_addr3 << ", BSSID=" << m_addr2;
+            os << ", DA(RA)=" << m_addr1 << ", SA=" << m_addr3 << ", BSSID(TA)=" << m_addr2;
         }
         else if (m_ctrlToDs && !m_ctrlFromDs)
         {
-            os << ", DA=" << m_addr3 << ", SA=" << m_addr2 << ", BSSID=" << m_addr1;
+            os << ", DA=" << m_addr3 << ", SA(TA)=" << m_addr2 << ", BSSID(RA)=" << m_addr1;
         }
         else if (m_ctrlToDs && m_ctrlFromDs)
         {
@@ -1196,6 +1165,26 @@
         }
         os << ", FragNumber=" << std::hex << (int)m_seqFrag << std::dec
            << ", SeqNumber=" << m_seqSeq;
+        if (IsQosData())
+        {
+            os << ", tid=" << +m_qosTid;
+            if (IsQosAmsdu())
+            {
+                os << ", A-MSDU";
+            }
+            if (IsQosNoAck())
+            {
+                os << ", ack=NoAck";
+            }
+            else if (IsQosAck())
+            {
+                os << ", ack=NormalAck";
+            }
+            else if (IsQosBlockAck())
+            {
+                os << ", ack=BlockAck";
+            }
+        }
         break;
     case WIFI_MAC_CTL_BACKREQ:
     case WIFI_MAC_CTL_BACKRESP:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-mac-header.h ns-3.43/src/wifi/model/wifi-mac-header.h
--- ns-3.42/src/wifi/model/wifi-mac-header.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-mac-header.h	2024-10-09 16:41:10.128656900 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2006, 2009 INRIA
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  * Author: Mirko Banchi <mk.banchi@gmail.com>
@@ -119,14 +108,13 @@
         ADDR4
     };
 
-    WifiMacHeader();
+    WifiMacHeader() = default;
     /**
      * Construct a MAC header of the given type
      *
      * \param type the MAC header type
      */
     WifiMacHeader(WifiMacType type);
-    ~WifiMacHeader() override;
 
     /**
      * \brief Get the type ID.
@@ -674,30 +662,30 @@
      */
     void PrintFrameControl(std::ostream& os) const;
 
-    uint8_t m_ctrlType;            ///< control type
-    uint8_t m_ctrlSubtype;         ///< control subtype
-    uint8_t m_ctrlToDs;            ///< control to DS
-    uint8_t m_ctrlFromDs;          ///< control from DS
-    uint8_t m_ctrlMoreFrag;        ///< control more fragments
-    uint8_t m_ctrlRetry;           ///< control retry
-    uint8_t m_ctrlPowerManagement; ///< control power management
-    uint8_t m_ctrlMoreData;        ///< control more data
-    uint8_t m_ctrlWep;             ///< control WEP
-    uint8_t m_ctrlOrder;  ///< control order (set to 1 for QoS Data and Management frames to signify
-                          ///< that HT/VHT/HE control field is present, knowing that the latter are
-                          ///< not implemented yet)
-    uint16_t m_duration;  ///< duration
-    Mac48Address m_addr1; ///< address 1
-    Mac48Address m_addr2; ///< address 2
-    Mac48Address m_addr3; ///< address 3
-    uint8_t m_seqFrag;    ///< sequence fragment
-    uint16_t m_seqSeq;    ///< sequence sequence
-    Mac48Address m_addr4; ///< address 4
-    uint8_t m_qosTid;     ///< QoS TID
-    uint8_t m_qosEosp;    ///< QoS EOSP
-    uint8_t m_qosAckPolicy; ///< QoS Ack policy
-    uint8_t m_amsduPresent; ///< A-MSDU present
-    uint8_t m_qosStuff;     ///< QoS stuff
+    uint8_t m_ctrlType{0};            ///< control type
+    uint8_t m_ctrlSubtype{0};         ///< control subtype
+    uint8_t m_ctrlToDs{0};            ///< control to DS
+    uint8_t m_ctrlFromDs{0};          ///< control from DS
+    uint8_t m_ctrlMoreFrag{0};        ///< control more fragments
+    uint8_t m_ctrlRetry{0};           ///< control retry
+    uint8_t m_ctrlPowerManagement{0}; ///< control power management
+    uint8_t m_ctrlMoreData{0};        ///< control more data
+    uint8_t m_ctrlWep{0};             ///< control WEP
+    uint8_t m_ctrlOrder{0}; ///< control order (set to 1 for QoS Data and Management frames to
+                            ///< signify that HT/VHT/HE control field is present, knowing that the
+                            ///< latter are not implemented yet)
+    uint16_t m_duration{0}; ///< duration
+    Mac48Address m_addr1{}; ///< address 1
+    Mac48Address m_addr2{}; ///< address 2
+    Mac48Address m_addr3{}; ///< address 3
+    uint8_t m_seqFrag{0};   ///< sequence fragment
+    uint16_t m_seqSeq{0};   ///< sequence sequence
+    Mac48Address m_addr4{}; ///< address 4
+    uint8_t m_qosTid{0};    ///< QoS TID
+    uint8_t m_qosEosp{0};   ///< QoS EOSP
+    uint8_t m_qosAckPolicy{0}; ///< QoS Ack policy
+    uint8_t m_amsduPresent{0}; ///< A-MSDU present
+    uint8_t m_qosStuff{0};     ///< QoS stuff
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-mac-queue.cc ns-3.43/src/wifi/model/wifi-mac-queue.cc
--- ns-3.42/src/wifi/model/wifi-mac-queue.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-mac-queue.cc	2024-10-09 16:41:10.128656900 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2005, 2009 INRIA
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
